/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the GoogleAnalyticsControllerActionMetric200ResponseInner type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GoogleAnalyticsControllerActionMetric200ResponseInner{}

// GoogleAnalyticsControllerActionMetric200ResponseInner struct for GoogleAnalyticsControllerActionMetric200ResponseInner
type GoogleAnalyticsControllerActionMetric200ResponseInner struct {
	Label    *string `json:"label,omitempty"`
	Value    *string `json:"value,omitempty"`
	Category *string `json:"category,omitempty"`
}

// NewGoogleAnalyticsControllerActionMetric200ResponseInner instantiates a new GoogleAnalyticsControllerActionMetric200ResponseInner object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGoogleAnalyticsControllerActionMetric200ResponseInner() *GoogleAnalyticsControllerActionMetric200ResponseInner {
	this := GoogleAnalyticsControllerActionMetric200ResponseInner{}
	return &this
}

// NewGoogleAnalyticsControllerActionMetric200ResponseInnerWithDefaults instantiates a new GoogleAnalyticsControllerActionMetric200ResponseInner object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGoogleAnalyticsControllerActionMetric200ResponseInnerWithDefaults() *GoogleAnalyticsControllerActionMetric200ResponseInner {
	this := GoogleAnalyticsControllerActionMetric200ResponseInner{}
	return &this
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *GoogleAnalyticsControllerActionMetric200ResponseInner) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAnalyticsControllerActionMetric200ResponseInner) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *GoogleAnalyticsControllerActionMetric200ResponseInner) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *GoogleAnalyticsControllerActionMetric200ResponseInner) SetLabel(v string) {
	o.Label = &v
}

// GetValue returns the Value field value if set, zero value otherwise.
func (o *GoogleAnalyticsControllerActionMetric200ResponseInner) GetValue() string {
	if o == nil || IsNil(o.Value) {
		var ret string
		return ret
	}
	return *o.Value
}

// GetValueOk returns a tuple with the Value field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAnalyticsControllerActionMetric200ResponseInner) GetValueOk() (*string, bool) {
	if o == nil || IsNil(o.Value) {
		return nil, false
	}
	return o.Value, true
}

// HasValue returns a boolean if a field has been set.
func (o *GoogleAnalyticsControllerActionMetric200ResponseInner) HasValue() bool {
	if o != nil && !IsNil(o.Value) {
		return true
	}

	return false
}

// SetValue gets a reference to the given string and assigns it to the Value field.
func (o *GoogleAnalyticsControllerActionMetric200ResponseInner) SetValue(v string) {
	o.Value = &v
}

// GetCategory returns the Category field value if set, zero value otherwise.
func (o *GoogleAnalyticsControllerActionMetric200ResponseInner) GetCategory() string {
	if o == nil || IsNil(o.Category) {
		var ret string
		return ret
	}
	return *o.Category
}

// GetCategoryOk returns a tuple with the Category field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAnalyticsControllerActionMetric200ResponseInner) GetCategoryOk() (*string, bool) {
	if o == nil || IsNil(o.Category) {
		return nil, false
	}
	return o.Category, true
}

// HasCategory returns a boolean if a field has been set.
func (o *GoogleAnalyticsControllerActionMetric200ResponseInner) HasCategory() bool {
	if o != nil && !IsNil(o.Category) {
		return true
	}

	return false
}

// SetCategory gets a reference to the given string and assigns it to the Category field.
func (o *GoogleAnalyticsControllerActionMetric200ResponseInner) SetCategory(v string) {
	o.Category = &v
}

func (o GoogleAnalyticsControllerActionMetric200ResponseInner) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GoogleAnalyticsControllerActionMetric200ResponseInner) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.Value) {
		toSerialize["value"] = o.Value
	}
	if !IsNil(o.Category) {
		toSerialize["category"] = o.Category
	}
	return toSerialize, nil
}

type NullableGoogleAnalyticsControllerActionMetric200ResponseInner struct {
	value *GoogleAnalyticsControllerActionMetric200ResponseInner
	isSet bool
}

func (v NullableGoogleAnalyticsControllerActionMetric200ResponseInner) Get() *GoogleAnalyticsControllerActionMetric200ResponseInner {
	return v.value
}

func (v *NullableGoogleAnalyticsControllerActionMetric200ResponseInner) Set(val *GoogleAnalyticsControllerActionMetric200ResponseInner) {
	v.value = val
	v.isSet = true
}

func (v NullableGoogleAnalyticsControllerActionMetric200ResponseInner) IsSet() bool {
	return v.isSet
}

func (v *NullableGoogleAnalyticsControllerActionMetric200ResponseInner) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGoogleAnalyticsControllerActionMetric200ResponseInner(val *GoogleAnalyticsControllerActionMetric200ResponseInner) *NullableGoogleAnalyticsControllerActionMetric200ResponseInner {
	return &NullableGoogleAnalyticsControllerActionMetric200ResponseInner{value: val, isSet: true}
}

func (v NullableGoogleAnalyticsControllerActionMetric200ResponseInner) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGoogleAnalyticsControllerActionMetric200ResponseInner) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
